unit UnDefin;
//      .
// (C) Semyonov Eugene, Fwcs Corporation, 02/12/2001.


//  .
interface

const
  ScoTasks = 3;

type
  tFunct1 = Function(x,y:Extended):Extended; //  z=z(x,y).
  tFunctA = array[0..2] of tFunct1;          //  .
  tProced = procedure(x,y:Extended; var xg,yg:Extended);
  tProcAr = array[0..2] of tProced;          //  .

var
  Fun: tFunct1;                              //  
  Jn : tFunctA;                              //    .
  Jg : tProcAr;                              //    .


//  .
implementation


//  -  .
function Jn0(x,y:Extended):Extended;
 begin
  Jn0 := ( x*x+y*y );
 end;

procedure Jg0(x,y:Extended; var xg,yg:Extended);
 begin
  xg := 2*x;  yg := 2*y;
 end;


//  -  .
function Jn1(x,y:Extended):Extended;
 begin
  Jn1:=(y-x*x)*(y-x*x) + (1-x*x)*(1-x*x);  // fn1
 end;

procedure Jg1(x,y:Extended; var xg,yg:Extended);
 begin
  xg:=-4*x*(y+1-2*x*x);  yg:=2*(y-x*x);  // fn1
 end;


//     .
function Jn2(x,y:Extended):Extended;
 var
  r : Extended;
 begin
  r:=sqrt(x*x+y*y);
  if (r<0.00001) then  r:=1  else  r:=(sin(r))/r;
  Jn2:=r;
 end;

procedure Jg2(x,y:Extended; var xg,yg:Extended);
 var
  r : Extended;
 begin
  r:=sqrt(x*x+y*y);
  if (r<0.000001) then  begin  xg:=0; yg:=0;  end
   else begin
    xg := ( (cos(r)) - ( (sin(r))/r )*x/r/r);
    yg := ( (cos(r)) - ( (sin(r))/r )*y/r/r);
        end;
 end;


//    2x  .
//  : (x,y) -  .
// : return=    (x,y).
// P.S.     .
begin
 //   .
  @Jn[0] := @Jn0;
  @Jn[1] := @Jn1;
  @Jn[2] := @Jn2;

 //   .
  @Jg[0] := @Jg0;
  @Jg[1] := @Jg1;
  @Jg[2] := @Jg2;

  Fun:=Jn1;  //  
end.
