
unit UnGraph;
//     
//      RGB   PaintBox.
//     "  #1".
// (C) Semyonov Eugene, Fwcs Corporation, 02/12/2001.


//  .
interface
  uses  UnDraw,  Graphics, Windows, SysUtils;

  function  RGBtoInt(r,g,b:Integer):LongWord;     //   ...
  function  ValToRGB(va,mi,ma:Extended):LongWord; //   .
  function  ValDiRGB(va,mi,ma:Extended):LongWord; //   .
  procedure Plot(x,y:Integer; c:LongWord);        //   RGB-.

var
  DiColRGB: Array[0..fclScore,0..3] of LongWord;  // (.; ,R,G,B) 


//  .
implementation
  uses  UnOptim1,  math;//,SysUtils, Graphics;


//      RGB-.
// : ()  R,G,B   [0..255];
// : ( )  .
function RGBtoInt(r,g,b:Integer):LongWord;
 begin
  RGBtoInt:=b*65536+g*256+r;
 end;


//    
// :  - , , ;
// : ( )  .
function ValToRGB(va,mi,ma:Extended):LongWord;
 var
  r,g,b:LongInt;
  sco, calc:LongInt;
 begin
  sco:=fmMnForm.seScoGrd.Value-1;
  calc:=Floor((va-mi)/(ma-mi)*(sco+0.99));
  r:= (calc*( (DiColRGB[fclWgrMa,1]-DiColRGB[fclWgrMi,1])
           ) div sco)  + DiColRGB[fclWgrMi,1];
  g:= calc*( (DiColRGB[fclWgrMa,2]-DiColRGB[fclWgrMi,2])
           ) div sco  + DiColRGB[fclWgrMi,2];
  b:= calc*( (DiColRGB[fclWgrMa,3]-DiColRGB[fclWgrMi,3])
           ) div sco  + DiColRGB[fclWgrMi,3];
  ValToRGB:=b*65536+g*256+r;
 end;


//    
// :  - , , ;
// : ( )  .
function ValDiRGB(va,mi,ma:Extended):LongWord;
 var
  v:LongWord;
 begin
  v:=Floor((va-mi)/(ma-mi)*9.99);
  ValDiRGB:=DiColRGB[v,0];
 end;


//   RGB-.
// :  X,Y;  .
procedure Plot(x,y:Integer; c:LongWord);
 begin
  with fmMnForm, pbDrawAr, Canvas do
   begin
    Pen.Color := c;
    MoveTo(x,y);
    LineTo(x-1,y-1);
   end;
 end;

end.

