
unit UnMinim;
//   ,  
//     .
//     "  #1".
// (C) Semyonov Eugene, Fwcs Corporation, 03/12/2001.


//  .
interface

function GradSkor(x0,y0:Extended; var xm,ym:Extended; var N:LongWord):Extended;
                 //     " ".

//const

var
  eps : Extended;    //   .
  hst : Extended;    //  .
  Uoo : Extended;    //   -   .
  CurTsk:Integer;    //   .
  Solut: Array[1..10000,1..2] of Extended; //  .


//  .
implementation
  uses  UnDefin;


//       .
//  : (x1,y1), (x2,y2) -  .
function ro2(x1,y1,  x2,y2 :Extended):Extended;
begin
  ro2:=sqrt( (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1) );
end;


//   ,      .
//      Uoo.
//  : u[DIM] -  .
function OutSpace(x,y:Extended):Boolean;
begin
  OutSpace:=(ro2(x,y, 0,0) <= Uoo);   //   Uoo.
end;


//      .
function J(alf, x,y :Extended):Extended;
var
  xg,yg:Extended;              //   .
  xf,yf:Extended;              //  .
begin
  Jg[CurTsk](x,y, xg,yg);      //   ug   u.
  xf:=x-alf*xg;                //  ,   alp
  yf:=y-alf*yg;                //   u   .
  J:=Jn[CurTsk](xf,yf);        //     .
end;


//          .
//      a,b.
procedure FindSegm(x,y:Extended; var a,b:Extended);
var
  u1, u2 : Extended;               //    .
begin
  a:=0;  b:=hst;                   //    .
  u1:=J(a,x,y);  u2:=J(b,x,y);     //    .

 if (u1>=u2) then begin            //   :
   a:=a-hst;                       //     (b=a+h+h).

   while ((u1>=u2) and (b<Uoo-hst))//    ,
    do begin                       //       .
     a:=a+hst;  b:=b+hst;          //   .
     u1:=u2;                       //   
     u2:=J(b,x,y);                 //    .
    end;
 end;
end;


//     "  ".
//  : ,       .
// :     ;
//          uz -  .
 {
double Min1(double u[])
 double a1,b1, u1,u2, Ju1,Ju2;     //  .
 double d = e/100 ;                //   .
 a1 = a;  b1 = b ;                 //   .

 while (!( sqrt((b1-a1)*(b1-a1)) < e )) //abs(b1-a1) >= e
  {
  u1=(a1+b1-d)/2; u2=(a1+b1+d)/2; Ju1=J(u1, u); Ju2=J(u2, u);
  if (Ju1<=Ju2) b1=u2; else a1=u1;
  |

 uz=(u1+u2)/2;                     // ,   .
 return(J(uz, u));                 //     uz.
 }


//     " ".
//  : ,       .
// :     ;
//          uz -  .
function Min2(x,y, a,b:Extended; var uz:Extended):Extended;
var
  s1,s2:Extended; //  .
  a1,b1, u1,u2, Ju1,Ju2:Extended; //  .
begin
 s1:=(3-sqrt(5))/2;  s2:=(sqrt(5)-1)/2 ;  //  .
 a1:=a;  b1:=b ;                  //   .

 u1:=a1+s1*(b1-a1);  u2:=a1+s2*(b1-a1);
 Ju1:=J(u1, x,y);  Ju2:=J(u2, x,y);
 if (Ju1<=Ju2) then        b1:=u2
               else begin  a1:=u1; u1:=u2; Ju1:=Ju2;  end;

 while (abs(b1-a1) >= eps ) do
  begin
   u2:=a1+b1-u1;  Ju2:=J(u2, x,y);
   if (u2<u1)
    then begin
          if (Ju2<=Ju1) then
            begin  b1:=u1; u1:=u2; Ju1:=Ju2; end else a1:=u2;
         end
    else begin
          if (Ju1<=Ju2) then
            b1:=u2  else begin  a1:=u1; u1:=u2; Ju1:=Ju2; end;
         end;
  end;

  uz:=u1;                         //   .
  Min2:=Ju1;                      //     uz.
end;


//    " ".
function Alpha(x,y:Extended):Extended;
var
  a,b: Extended; //  ,    .
  uz : Extended; //  .
begin
  FindSegm(x,y, a,b);             //   .
   Min2(x,y, a,b, uz);            //   alpha
  Alpha:=uz;                      //    .
end;


//     " ".
//  : (x0,y0) -   .
// :    2x ;
//          (xm,ym)  2x .
function GradSkor(x0,y0:Extended; var xm,ym:Extended; var N:LongWord):Extended;
label
  lp1;
var
//  i:Integer ;                        //  .
  alp:Extended ;                     //  .
  xg,yg:Extended;                    //   .
  x,y:Extended;                      //  .
  x1,y1:Extended;                    //  .
begin
  N:=0;                            //  
  x1:=x0;  y1:=y0;                 //  .

lp1 :  Inc(N);                     //  .  .
  x:=x1;  y:=y1;                   //  .
  Jg[CurTsk](x,y, xg,yg);          //  
  alp:=Alpha(x,y);                 //   .
  x1:=x-alp*xg;  y1:=y-alp*yg;     //  .
  Solut[N,1]:=x1;  Solut[N,2]:=y1; //    .

  if ( (ro2(x,y, x1,y1)>=eps) and     //      
   (OutSpace(x1,y1)) ) then goto lp1; //   , .

  xm:=x1;  ym:=y1;                 //  .
  GradSkor:=Jn[CurTsk](xm,ym);     //  .
end;

end.

